// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.5.1
// - protoc             v4.25.6
// source: release.proto

package gen

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.64.0 or later.
const _ = grpc.SupportPackageIsVersion9

const (
	Releases_GetReleaseByID_FullMethodName                  = "/martiancloud.phobos.api.release.Releases/GetReleaseByID"
	Releases_GetReleases_FullMethodName                     = "/martiancloud.phobos.api.release.Releases/GetReleases"
	Releases_CreateRelease_FullMethodName                   = "/martiancloud.phobos.api.release.Releases/CreateRelease"
	Releases_UpdateRelease_FullMethodName                   = "/martiancloud.phobos.api.release.Releases/UpdateRelease"
	Releases_DeleteRelease_FullMethodName                   = "/martiancloud.phobos.api.release.Releases/DeleteRelease"
	Releases_AddParticipantToRelease_FullMethodName         = "/martiancloud.phobos.api.release.Releases/AddParticipantToRelease"
	Releases_RemoveParticipantFromRelease_FullMethodName    = "/martiancloud.phobos.api.release.Releases/RemoveParticipantFromRelease"
	Releases_UpdateReleaseDeploymentPipeline_FullMethodName = "/martiancloud.phobos.api.release.Releases/UpdateReleaseDeploymentPipeline"
)

// ReleasesClient is the client API for Releases service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
//
// Releases implements all functionality related to project Releases.
type ReleasesClient interface {
	// GetReleaseByID returns a release by ID.
	GetReleaseByID(ctx context.Context, in *GetReleaseByIdRequest, opts ...grpc.CallOption) (*Release, error)
	// GetReleases returns a list of releases.
	GetReleases(ctx context.Context, in *GetReleasesRequest, opts ...grpc.CallOption) (*GetReleasesResponse, error)
	// CreateRelease creates a new Release.
	CreateRelease(ctx context.Context, in *CreateReleaseRequest, opts ...grpc.CallOption) (*Release, error)
	// UpdateRelease updates a Release.
	UpdateRelease(ctx context.Context, in *UpdateReleaseRequest, opts ...grpc.CallOption) (*Release, error)
	// DeleteRelease deletes a Release.
	DeleteRelease(ctx context.Context, in *DeleteReleaseRequest, opts ...grpc.CallOption) (*emptypb.Empty, error)
	// AddParticipantToRelease adds a participant to a Release.
	AddParticipantToRelease(ctx context.Context, in *AddParticipantToReleaseRequest, opts ...grpc.CallOption) (*Release, error)
	// RemoveParticipantFromRelease removes a participant from a Release.
	RemoveParticipantFromRelease(ctx context.Context, in *RemoveParticipantFromReleaseRequest, opts ...grpc.CallOption) (*Release, error)
	// UpdateReleaseDeploymentPipeline updates a release deployment pipeline.
	UpdateReleaseDeploymentPipeline(ctx context.Context, in *UpdateReleaseDeploymentPipelineRequest, opts ...grpc.CallOption) (*Pipeline, error)
}

type releasesClient struct {
	cc grpc.ClientConnInterface
}

func NewReleasesClient(cc grpc.ClientConnInterface) ReleasesClient {
	return &releasesClient{cc}
}

func (c *releasesClient) GetReleaseByID(ctx context.Context, in *GetReleaseByIdRequest, opts ...grpc.CallOption) (*Release, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Release)
	err := c.cc.Invoke(ctx, Releases_GetReleaseByID_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) GetReleases(ctx context.Context, in *GetReleasesRequest, opts ...grpc.CallOption) (*GetReleasesResponse, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(GetReleasesResponse)
	err := c.cc.Invoke(ctx, Releases_GetReleases_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) CreateRelease(ctx context.Context, in *CreateReleaseRequest, opts ...grpc.CallOption) (*Release, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Release)
	err := c.cc.Invoke(ctx, Releases_CreateRelease_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) UpdateRelease(ctx context.Context, in *UpdateReleaseRequest, opts ...grpc.CallOption) (*Release, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Release)
	err := c.cc.Invoke(ctx, Releases_UpdateRelease_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) DeleteRelease(ctx context.Context, in *DeleteReleaseRequest, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, Releases_DeleteRelease_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) AddParticipantToRelease(ctx context.Context, in *AddParticipantToReleaseRequest, opts ...grpc.CallOption) (*Release, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Release)
	err := c.cc.Invoke(ctx, Releases_AddParticipantToRelease_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) RemoveParticipantFromRelease(ctx context.Context, in *RemoveParticipantFromReleaseRequest, opts ...grpc.CallOption) (*Release, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Release)
	err := c.cc.Invoke(ctx, Releases_RemoveParticipantFromRelease_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *releasesClient) UpdateReleaseDeploymentPipeline(ctx context.Context, in *UpdateReleaseDeploymentPipelineRequest, opts ...grpc.CallOption) (*Pipeline, error) {
	cOpts := append([]grpc.CallOption{grpc.StaticMethod()}, opts...)
	out := new(Pipeline)
	err := c.cc.Invoke(ctx, Releases_UpdateReleaseDeploymentPipeline_FullMethodName, in, out, cOpts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// ReleasesServer is the server API for Releases service.
// All implementations must embed UnimplementedReleasesServer
// for forward compatibility.
//
// Releases implements all functionality related to project Releases.
type ReleasesServer interface {
	// GetReleaseByID returns a release by ID.
	GetReleaseByID(context.Context, *GetReleaseByIdRequest) (*Release, error)
	// GetReleases returns a list of releases.
	GetReleases(context.Context, *GetReleasesRequest) (*GetReleasesResponse, error)
	// CreateRelease creates a new Release.
	CreateRelease(context.Context, *CreateReleaseRequest) (*Release, error)
	// UpdateRelease updates a Release.
	UpdateRelease(context.Context, *UpdateReleaseRequest) (*Release, error)
	// DeleteRelease deletes a Release.
	DeleteRelease(context.Context, *DeleteReleaseRequest) (*emptypb.Empty, error)
	// AddParticipantToRelease adds a participant to a Release.
	AddParticipantToRelease(context.Context, *AddParticipantToReleaseRequest) (*Release, error)
	// RemoveParticipantFromRelease removes a participant from a Release.
	RemoveParticipantFromRelease(context.Context, *RemoveParticipantFromReleaseRequest) (*Release, error)
	// UpdateReleaseDeploymentPipeline updates a release deployment pipeline.
	UpdateReleaseDeploymentPipeline(context.Context, *UpdateReleaseDeploymentPipelineRequest) (*Pipeline, error)
	mustEmbedUnimplementedReleasesServer()
}

// UnimplementedReleasesServer must be embedded to have
// forward compatible implementations.
//
// NOTE: this should be embedded by value instead of pointer to avoid a nil
// pointer dereference when methods are called.
type UnimplementedReleasesServer struct{}

func (UnimplementedReleasesServer) GetReleaseByID(context.Context, *GetReleaseByIdRequest) (*Release, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetReleaseByID not implemented")
}
func (UnimplementedReleasesServer) GetReleases(context.Context, *GetReleasesRequest) (*GetReleasesResponse, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetReleases not implemented")
}
func (UnimplementedReleasesServer) CreateRelease(context.Context, *CreateReleaseRequest) (*Release, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateRelease not implemented")
}
func (UnimplementedReleasesServer) UpdateRelease(context.Context, *UpdateReleaseRequest) (*Release, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateRelease not implemented")
}
func (UnimplementedReleasesServer) DeleteRelease(context.Context, *DeleteReleaseRequest) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DeleteRelease not implemented")
}
func (UnimplementedReleasesServer) AddParticipantToRelease(context.Context, *AddParticipantToReleaseRequest) (*Release, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddParticipantToRelease not implemented")
}
func (UnimplementedReleasesServer) RemoveParticipantFromRelease(context.Context, *RemoveParticipantFromReleaseRequest) (*Release, error) {
	return nil, status.Errorf(codes.Unimplemented, "method RemoveParticipantFromRelease not implemented")
}
func (UnimplementedReleasesServer) UpdateReleaseDeploymentPipeline(context.Context, *UpdateReleaseDeploymentPipelineRequest) (*Pipeline, error) {
	return nil, status.Errorf(codes.Unimplemented, "method UpdateReleaseDeploymentPipeline not implemented")
}
func (UnimplementedReleasesServer) mustEmbedUnimplementedReleasesServer() {}
func (UnimplementedReleasesServer) testEmbeddedByValue()                  {}

// UnsafeReleasesServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ReleasesServer will
// result in compilation errors.
type UnsafeReleasesServer interface {
	mustEmbedUnimplementedReleasesServer()
}

func RegisterReleasesServer(s grpc.ServiceRegistrar, srv ReleasesServer) {
	// If the following call pancis, it indicates UnimplementedReleasesServer was
	// embedded by pointer and is nil.  This will cause panics if an
	// unimplemented method is ever invoked, so we test this at initialization
	// time to prevent it from happening at runtime later due to I/O.
	if t, ok := srv.(interface{ testEmbeddedByValue() }); ok {
		t.testEmbeddedByValue()
	}
	s.RegisterService(&Releases_ServiceDesc, srv)
}

func _Releases_GetReleaseByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetReleaseByIdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).GetReleaseByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_GetReleaseByID_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).GetReleaseByID(ctx, req.(*GetReleaseByIdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_GetReleases_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(GetReleasesRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).GetReleases(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_GetReleases_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).GetReleases(ctx, req.(*GetReleasesRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_CreateRelease_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CreateReleaseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).CreateRelease(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_CreateRelease_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).CreateRelease(ctx, req.(*CreateReleaseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_UpdateRelease_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateReleaseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).UpdateRelease(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_UpdateRelease_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).UpdateRelease(ctx, req.(*UpdateReleaseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_DeleteRelease_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(DeleteReleaseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).DeleteRelease(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_DeleteRelease_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).DeleteRelease(ctx, req.(*DeleteReleaseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_AddParticipantToRelease_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddParticipantToReleaseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).AddParticipantToRelease(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_AddParticipantToRelease_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).AddParticipantToRelease(ctx, req.(*AddParticipantToReleaseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_RemoveParticipantFromRelease_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(RemoveParticipantFromReleaseRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).RemoveParticipantFromRelease(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_RemoveParticipantFromRelease_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).RemoveParticipantFromRelease(ctx, req.(*RemoveParticipantFromReleaseRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _Releases_UpdateReleaseDeploymentPipeline_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(UpdateReleaseDeploymentPipelineRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ReleasesServer).UpdateReleaseDeploymentPipeline(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Releases_UpdateReleaseDeploymentPipeline_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ReleasesServer).UpdateReleaseDeploymentPipeline(ctx, req.(*UpdateReleaseDeploymentPipelineRequest))
	}
	return interceptor(ctx, in, info, handler)
}

// Releases_ServiceDesc is the grpc.ServiceDesc for Releases service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Releases_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "martiancloud.phobos.api.release.Releases",
	HandlerType: (*ReleasesServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "GetReleaseByID",
			Handler:    _Releases_GetReleaseByID_Handler,
		},
		{
			MethodName: "GetReleases",
			Handler:    _Releases_GetReleases_Handler,
		},
		{
			MethodName: "CreateRelease",
			Handler:    _Releases_CreateRelease_Handler,
		},
		{
			MethodName: "UpdateRelease",
			Handler:    _Releases_UpdateRelease_Handler,
		},
		{
			MethodName: "DeleteRelease",
			Handler:    _Releases_DeleteRelease_Handler,
		},
		{
			MethodName: "AddParticipantToRelease",
			Handler:    _Releases_AddParticipantToRelease_Handler,
		},
		{
			MethodName: "RemoveParticipantFromRelease",
			Handler:    _Releases_RemoveParticipantFromRelease_Handler,
		},
		{
			MethodName: "UpdateReleaseDeploymentPipeline",
			Handler:    _Releases_UpdateReleaseDeploymentPipeline_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "release.proto",
}
